# -*- rpm-spec -*-
# $Id: kernel-image-aw-smp,v 1.47 2003/09/03 11:58:45 ed Exp $
##
%define kernel_base_version	2.4.21
%define kernel_extra_version	%nil
%define krelease		alt23
%define kernel_extra_version_numeric 1.0.0
%define kversion                %kernel_base_version%kernel_extra_version
%define flavour                 aw-smp
%def_enable ccache
%{?__ccache_cc: %define _disable_ccache 1}

%if_enabled ccache
%define kcc "ccache %kgcc"
%else
%define kcc "%kgcc"
%endif

Name: kernel-image-%flavour
Version: %kversion
Release: %krelease
Serial: 1

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: System/Kernel and hardware
Url: http://www.kernel.org/
Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>

Source1: config-%flavour
Source2: rhkmvtag.c
%define rhkmvtag	%SOURCE2

%add_patch_list kernel-feat-i2c kernel-fix-core kernel-fix-build kernel-fix-security
%add_patch_list kernel-fix-drivers-net kernel-fix-drivers-ide kernel-fix-drivers-scsi
%add_patch_list kernel-fix-drivers-usb  kernel-fix-drivers-pci  kernel-fix-lvm
%add_patch_list kernel-feat-addon kernel-feat-fs-xfs kernel-feat-dm kernel-feat-evms
%add_patch_list kernel-fix-drivers-md kernel-feat-net-net_mod kernel-feat-acpi 
%add_patch_list kernel-feat-fs-nfs-aw kernel-feat-kconfig kernel-feat-drivers-block-enbd
%add_patch_list kernel-feat-core-O1sched kernel-feat-iscsi kernel-feat-drivers-ide-hotswap

#%%add_patch_list kernel-feat-kgdb

ExclusiveOS:	Linux

BuildPreReq: kernel-build-tools

%if_enabled ccache
BuildRequires: ccache
%endif

BuildRequires: coreutils gcc2.96 libdb4.0-devel perl flex dev86
BuildRequires: rpm >= 4.0.2-75
BuildRequires: kernel-source-%{kernel_base_version}
BuildRequires: %get_patch_list

Requires: bootloader-utils >= 0.1-alt7, modutils, mkinitrd >= 1:2.8.6-alt1

Prereq: coreutils
Prereq: modutils >= 2.4.17
Obsoletes: kernel-modules
ExclusiveArch: %{ix86}

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.
NOTE: This kernel is server-oriented, don't use it on your desktops 
unless you know what you are doing.
The following patches applied:
%format_patch_list

%package -n kernel-headers-%flavour
Summary: Header files for the Linux kernel
Group: System/Kernel and hardware
Requires: kernel-headers-common >= 1.1
Provides: kernel-headers, kernel-headers-aw

%description -n kernel-headers-%flavour
These are the C header files for the Linux kernel, which define
structures and constants that are needed when building most standard
programs under Linux, as well as to rebuild the kernel.

%package -n kernel-headers-modules-%flavour
Summary: Additional files, needed for building kernel modules
Group: System/Kernel and hardware

%description -n kernel-headers-modules-%flavour
These are the additional files for the Linux kernel, which
needed when building kernel modules. 
Don't use it for any purposes except building a kernel modules.

%prep

%__rm -rf kernel-source-%kversion

%__tar -jxf %kernel_src/kernel-source-%kversion.tar.bz2

%setup -D -T -n kernel-source-%kversion

echo "patches = %_patch_list"

%apply_patches

%__mv -f Makefile Makefile.orig
%__sed -e 's/EXTRAVERSION =.*/EXTRAVERSION =/g' \
    -e 's/CC.*$(CROSS_COMPILE)gcc/CC		= %kgcc/g' \
    Makefile.orig >Makefile


%build

KERNEL_BUILD_DIR=`pwd`

KernelVer=%kversion-%flavour-%krelease

echo "Building Kernel $KernelVer"

:> arch/%base_arch/defconfig

%__cat %SOURCE1 >> arch/%base_arch/defconfig

%__make mrproper CC=%kcc EXTRAVERSION=%kernel_extra_version-%flavour-%krelease

%__make oldconfig CC=%kcc EXTRAVERSION=%kernel_extra_version-%flavour-%krelease

### It's a hack, but a useful hack:
cmp -s .config %SOURCE1 || %__cp -vf .config %SOURCE1

%__make dep clean CC=%kcc EXTRAVERSION=%kernel_extra_version-%flavour-%krelease

%__make include/linux/version.h CC=%kcc EXTRAVERSION=%kernel_extra_version-%flavour-%krelease

%__make bzImage CC=%kcc EXTRAVERSION=%kernel_extra_version-%flavour-%krelease

%__make modules CC=%kcc EXTRAVERSION=%kernel_extra_version-%flavour-%krelease YACC="bison -y"

echo "Kernel built $KernelVer"

%install

KernelVer=%kversion-%flavour-%krelease

%__install -D System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
%__install arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
%__install .config $RPM_BUILD_ROOT/boot/config-$KernelVer

%__make modules_install \
    INSTALL_MOD_PATH=$RPM_BUILD_ROOT \
    KERNELRELEASE=$KernelVer \
    EXTRAVERSION=%kernel_extra_version-%flavour-%krelease

%__cc -o rhkmvtag %rhkmvtag init/version.o
./rhkmvtag >$RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag ||:
%__rm -f rhkmvtag

%__install -d $RPM_BUILD_ROOT/usr/include/linux-%version-%flavour/include

%__cp -a ./include/{asm,asm-%base_arch,config,linux,math-emu,net,pcmcia,scsi,video} \
	$RPM_BUILD_ROOT/usr/include/linux-%version-%flavour/include

%__install -d ${RPM_BUILD_ROOT}%_usrsrc/linux-%version-%flavour/drivers/scsi
%__cp -a ./drivers/scsi/{{sd,scsi,hosts,scsi_obsolete}.h,scsi_module.c} \
	${RPM_BUILD_ROOT}%_usrsrc/linux-%version-%flavour/drivers/scsi/

%__mkdir -p $RPM_BUILD_ROOT/etc/apt/apt.conf.d

echo '
RPM {
    Allow-Duplicated {"^kernel-image-%{flavour}$";};
};
' > $RPM_BUILD_ROOT/etc/apt/apt.conf.d/kernel-image-%{flavour}.conf

%__install -D .config $RPM_BUILD_ROOT/usr/src/linux-%version-%flavour/.config

%post

cd /boot
if [ -x /sbin/installkernel ];then
    /sbin/installkernel -a -c %kversion-%flavour-%krelease
fi

%preun
/sbin/modprobe loop 2> /dev/null > /dev/null

REMOVE=
if [ -f /etc/sysconfig/system ];then
		source /etc/sysconfig/system
		[[ "$CLASS" = "beginner" ]] && REMOVE=yes
fi
if [ -f /etc/sysconfig/installkernel ];then
		source /etc/sysconfig/installkernel
		[[ "$AUTOREMOVE" = [Yy][Ee][Ss] ]] && REMOVE=yes
		[[ "$AUTOREMOVE" = [Nn][Oo] ]] && REMOVE=
fi

BUILD=/lib/modules/%kversion-%flavour-%krelease/build

[[ -z $REMOVE ]] || /sbin/installkernel -a -R -c %kversion-%flavour-%krelease

%postun
cd /boot
if [ -f initrd-%kversion-%flavour-%krelease.img ];then
	%__rm -f initrd-%kversion-%flavour-%krelease.img
fi


%files
%defattr(644,root,root,755)
/boot/vmlinuz-%{version}-%{flavour}-%{krelease}
/boot/System.map-%{version}-%{flavour}-%{krelease}
/boot/config-%{version}-%{flavour}-%{krelease}
/lib/modules/%{version}-%{flavour}-%{krelease}
%_sysconfdir/apt/apt.conf.d/kernel-image-%{flavour}.conf
# Exclude drm modules from kernel package
#%exclude /lib/modules/%{version}-%{flavour}-%{krelease}/kernel/drivers/char/drm

%files -n kernel-headers-%flavour
%defattr(644,root,root,755)
%_includedir/linux-%{version}-%{flavour}

%files -n kernel-headers-modules-%flavour
%defattr(644,root,root,755)
%_usrsrc/linux-%version-%flavour/drivers

%changelog
* Wed Sep  3 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt23
- net_mod support returned back

* Mon Sep  1 2003 Zhenja Kaluta <tren@altlinux.ru> 1:2.4.21-alt22
- rebuild with new evms
- kernel-headers provides kernel-headers-aw now

* Fri Aug 22 2003 Zhenja Kaluta <tren@altlinux.ru> 1:2.4.21-alt21
- Added dummy into kernel to support nfs root
- XFS updated to 1.3 release
- ReiserFS support added
- net_mod support removed

* Fri Aug 22 2003 Zhenja Kaluta <tren@altlinux.ru> 1:2.4.21-alt20
- Added nfsroot support. NFS moved to kernel

* Wed Aug 20 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt19
- ide hotswap fixes (dma patch returned back)

* Mon Aug 11 2003 Zhenja Kaluta <tren@altlinux.ru> 1:2.4.21-alt18
- Build ide and md as modules. Applied new ide fix for it

* Fri Aug  8 2003 Zhenja Kaluta <trinfo@mail.ru> 1:2.4.21-alt17
- ide and md in kernel
- added ide hotswap patch

* Thu Aug  7 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt14
- kernel-headers-scsi package removed, kernel-headers-modules created

* Tue Aug 05 2003 Zhenja Kaluta <tren@altlinux.ru> 1:2.4.21-alt13
- Compiled with new evms, dm and md-fix

* Mon Aug 04 2003 Zhenja Kaluta <tren@altlinux.ru> 1:2.4.21-alt12.1
- Fixed boot impossibility

* Fri Aug  1 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt12
- kernel-headers-scsi package added
- LSI MegaRAID driver 2.00 series included
- SCSI tape support & IDESCSI driver included

* Mon Jul 28 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt11
- ACPI button support compiled in
- use new kernel-fix-core ('lost interrupt' bug fixed)

* Wed Jul 23 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt10
- i2c 2.8.0
- support for some ide chipsets compiled in

* Fri Jul 18 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt9
- new kernel-feat-fs-xfs

* Thu Jul 17 2003 Alexey Kotovich <a.kotovich@sam-solutions.net> 1:2.4.21-alt8
- default configuration was changed

* Thu Jul 17 2003 Alexey Kotovich <a.kotovich@sam-solutions.net> 1:2.4.21-alt7
- fr1 driver was included

* Thu Jul 10 2003 Zhenja Kaluta <tren@altlinux.ru> 1:2.4.21-alt6
- adopted to evms and dm split

* Tue Jul  8 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt5
- kernel-fix-lvm and kernel-fix-md added
- add formatted patch list to the %%description
- iptables and QoS futures are turned on

* Sat Jun 28 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt4
- kernel-fix{ide,scsi,usb,pci} patches added

* Wed Jun 25 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt3
- bug in the %preun fixed
- feat-i2c added to the patches list

* Thu Jun 19 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt2
- fr1 is turned off
- Provides kernel-headers now

* Tue Jun 17 2003 Ed V. Bartosh <ed@sam-solutions.net> 1:2.4.21-alt1
- kernel-fix-drivers-net and kernel-fix-core patchsets added
- Updated for 2.4.21 release

* Thu Jun  5 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc7-alt1
- Updated to rc7
- sinchronized with ALT kernel-std-up and policy

* Mon Jun 02 2003 Alexey Kotovich <a.kotovich@sam-solutions.net> 2.4.21rc2-alt3
- O(1) scheduler patch has been removed

* Fri May 23 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc2-alt3
- enbd support added
- fr1 support added

* Thu May 22 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc2-alt2
- kernel-feat-net-net_mod kernel-feat-kconfig patches added

* Wed May 14 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc2-alt1
- Updated to rc2
- install phase scripting errors corrected

* Tue May 13 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc1-alt4
- NFS patches (uid/gid mapping and I18N) added

* Wed May  7 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc1-alt3
- ACPI patch added

* Tue Apr 29 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc1-alt2
- O(1) scheduler patch added

* Tue Apr 22 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21rc1-alt1
- updated to rc1
- cosmetic changes of spec

* Tue Apr 22 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21pre7-alt4
- add flavor to the kernel-headers package name

* Fri Apr 18 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21pre7-alt3
- Updated version
- added kernel-fix-drivers-ide patchset
- remove unneeded version part from the packet's name

* Fri Apr 18 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21pre5-alt2
- spec improvemens according the policy

* Wed Apr  9 2003 Ed V. Bartosh <ed@sam-solutions.net> 2.4.21pre5-alt1
- initial AW release

* Mon Mar 31 2003 Peter Novodvorsky <nidd@altlinux.com> 2.4.21pre5-alt1
- initial release


